#include <Be.h>
#define RDW_LibSig "application/x-vnd.Rodgers-DebugWindow.Lib"
#define RDW_StatusAppSig "application/x-vnd.Rodgers-DebugWindowApp"
#define RDW_StatusWindowOpened 949500
#define RDW_StatusWindowRunning 949510
#define RDW_WhereAreYou 949520
#define RDW_ThereCanBeOnlyOne 949530
#define RDW_DisplayString 949540
#define RDW_UseThread 949550

__declspec(dllexport) class RDW_Forward:public BLooper
 {
  public:
   RDW_Forward(team_id t, BHandler *d);
   BMessenger *msgr;
   team_id team;
   BHandler *dest; 
   virtual bool QuitRequested();
   virtual void MessageReceived(BMessage *msg);
 };
/*
Create a RDW_Forward object in your code to in order to forward messages
to the "debug" window. To print text in the debug window (with the debug app
running), simply create a BMessage and pass it to this object. The BMessage
should contain the following items:

Type    Name      Contents
int32   length    The length of the string to be printed in the debug window.
                  This *IS* REQUIRED!!
char*   text      The text to be printed in the debug window. Obviously, this
                  is required.

At the moment, I am considering adding further options including support for
formatted text, and an application name/origin of the output text. In either
event, they are not currently implemented or supported. (Give me a break! I've
only been working on this for a few hours as of December 16, 1998 9:03 pm.)                  

Also note that the RDW_Forward class requires a team_id and a BHandler at time
of instantiation. This is basically a formality, and will likely be removed
later. For the time being, however, make a global pointer to a RDW_Forward 
object, allocate it with the new operator in your derived BApplication
constructor with a line of code similar to this:

forwarder=new RDW_Forward(Team(),this);

The reason this is going to be obsolete is that the app will receive numerous
RDW_StatusWindowRunning messages (when Stat2 or another app containing 
RDW_View is running) that point it in the right direction. 
*/

 class RDW_View;

__declspec(dllexport) class RDW_Rerouter:public BLooper
 {
  public:
   BMessage *annc;
   RDW_View *vew;
   BMessenger *dest;
   virtual bool QuitRequested();
   virtual void MessageReceived(BMessage *msg);
   RDW_Rerouter(RDW_View *vw,const char *name,int32 priority,int32 cap);
   RDW_Rerouter(RDW_View *vw);
 };
/*
This is a BLooper that reroutes messages to the proper RDW_View/debug view.
It also helps to ensure that only one of these views gets the messages to be
displayed. It's unlikely that you should ever create one of these directly.
*/

__declspec(dllexport) class RDW_View:public BView
 {
  public:
   RDW_Rerouter *rtr;
   BMessage *op;
   ~RDW_View();
   virtual status_t Archive(BMessage *data, bool deep=true) const;
   static RDW_View *Instantiate(BMessage *msg);
   BTextView *tv;
   team_id theteam;
   bool replicant;
   bool runrouter;
   int32 offset;
   BScrollView *sb;
   BDragger *drg;
   void Init();
   RDW_View(BMessage *archive);
   RDW_View(BRect frame,const char *name,int32 resizem,int32 flags);
   virtual void Pulse();
   virtual void MessageReceived(BMessage *msg);
 };
/*
This is the view of the debug window. You may never need to touch this
directly. I haven't figured out a reason why you'd want to yet.
Be aware that I have designed this to be a replicatable window, however
I have currently disabled that ability in the library. The reason is that
as a replicant, it doesn't seem to receive messages. (Most likely because the
container app doesn't send the required BMessages to the RDW_View or
RDW_Rerouter.)
*/

class RDW_Win:public BWindow
 {
  public:
   RDW_Win(BRect frame, const char *title, window_type type, uint32 flags, uint32 wspaces);
   RDW_View *mv;
  virtual ~RDW_Win(); 
virtual void MessageReceived(BMessage *msg);
virtual bool QuitRequested();
 };
/*
The cheapest, easiest way to add the debug window to your app is to add
this class. Just create this object, and add three "handlers" inside your
BApplication::MessageReceived() function to get make the window functional.
Take a look at Stat2.cpp .
*/

__declspec(dllexport) class RDW_App:public BApplication
 {
  public:
   RDW_App();
   BMessenger *msgr;
   BMessage *msga;
//   bool SetAutoOpen(bool yesno=false);
//   bool GetAutoOpen();
   void DisplayText(char *text);
   virtual void MessageReceived(BMessage *msg);
   bool QuitRequested();
  private:
   bool statapprunning;
   bool autoopen;
   RDW_Win *w;
   RDW_Rerouter *rtr;
   team_id tm;
   RDW_View *dv;   
 };
/*
Use this? Do such things I would not if I were you!! This is a preliminary
sketchwork (more or less) of a complete BApplication like Stat2. Don't use it!
I repeat: DON'T USE IT!!!
*/